=== debian/changelog ===
zeromq3 (4.2.5-1) unstable; urgency=medium

  * New upstream release (closes: #894244).
  * Update watch file.
  * Disable Vcs-* fields for now (closes: #791997, #844108).
  * Don't specify parallel to debhelper.
  * Update Standards-Version to 4.1.3 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 27 Mar 2018 18:56:19 +0000

zeromq3 (4.2.3-1) unstable; urgency=medium

  * New upstream release.
  * Build with NACK-Oriented Reliable Multicast (NORM) support
    (closes: #884300).
  * Build with Kerberos V5 Generic Security Services API (GSSAPI) support.
  * Update libzmq5 symbols for kFreeBSD.
  * Update debhelper level to 11 .
  * Update Standards-Version to 4.1.2:
    - remove libzmq5-dbg package and use the auto-generated one.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 17 Dec 2017 11:51:16 +0000

zeromq3 (4.2.2-1) unstable; urgency=medium

  * New upstream release.
  * Remove no_IPv6_on_Hurd.patch as applied upstream.
  * Remove dh-autoreconf build dependency.
  * Update Standards-Version to 4.0.0 and debhelper level to 10 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 18 Sep 2017 17:17:13 +0000
