=== debian/changelog ===
zeromq3 (4.3.1-3ubuntu2.1) disco-security; urgency=medium

  * SECURITY UPDATE: Unauthenticated client can cause a stack overflow on any
    server that is supposed to be protected by encryption/authentication,
    leading to a DoS (crash) or possibly other impact.
    - debian/patches/CVE-2019-13132.patch: create buffers large enough to
      contain arbitrary metadata.
    - CVE-2019-13132

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Wed, 03 Jul 2019 10:58:28 -0300

zeromq3 (4.3.1-3ubuntu2) disco; urgency=medium

  * d/libzmq5.symbols: revert previous symbols update, as that came from a
    draft API that was mistakenly enabled in a local build when a .git
    directory was detected. 

 -- Andreas Hasenack <andreas@canonical.com>  Tue, 19 Mar 2019 17:01:01 +0000

zeromq3 (4.3.1-3ubuntu1) disco; urgency=medium

  * d/libzmq5.symbols: updated symbols
  * d/p/validate-group-before-using.patch: validate the supplementary
    group used in the filter_ipc test before using it. (LP: #1820282)

 -- Andreas Hasenack <andreas@canonical.com>  Mon, 18 Mar 2019 16:36:40 +0000

zeromq3 (4.3.1-3) unstable; urgency=medium

  [ Luca Boccassi <bluca@debian.org> ]
  * Patch to prefer CXX11 atomics for PPC64 and RISC-V architectures.
  * test_pair_ipc fails on GNU/Hurd due to wildcard bind, mark it as XFAIL.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 26 Jan 2019 12:49:45 +0000

zeromq3 (4.3.1-2) unstable; urgency=medium

  * Update libzmq3-dev dependency.

  [ Luca Boccassi <bluca@debian.org> ]
  * Fix self tests failures.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 13 Jan 2019 18:19:53 +0000

zeromq3 (4.3.1-1) unstable; urgency=high

  * New upstream release.
  * Fix pointer overflow in zmq::v2_decoder_t::size_ready() leading to
    remote code execution (closes: #919098).
  * Update library symbols.
  * Update Standards-Version to 4.3.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 12 Jan 2019 17:37:00 +0000

zeromq3 (4.2.5-2) unstable; urgency=medium

  * Update Standards-Version to 4.1.5 .

  [ Luca Boccassi <luca.boccassi@gmail.com> ]
  * Stop libstdc++ symbols from being exported on Debian/[Hurd|kFreeBSD]
    (closes: #902380).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 25 Aug 2018 17:46:56 +0000
