=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: zeromq3
 Section: libs
 Priority: optional
-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: debhelper (>= 11),
  libpgm-dev (>= 5.2.122~dfsg),
  libsodium-dev,
@@ -10,7 +11,7 @@
  pkg-config,
  xmlto,
  asciidoc
-Standards-Version: 4.1.3
+Standards-Version: 4.3.0
 #Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/zeromq3.git
 #Vcs-Git: git://anonscm.debian.org/collab-maint/zeromq3.git
 Homepage: https://www.zeromq.org/
@@ -33,7 +34,7 @@
 Package: libzmq3-dev
 Architecture: any
 Section: libdevel
-Depends: libzmq5 (= ${binary:Version}), ${misc:Depends}
+Depends: libzmq5 (= ${binary:Version}), ${misc:Depends}, libpgm-dev (>= 5.2.122~dfsg), libsodium-dev, libnorm-dev, libkrb5-dev
 Conflicts: libzmq-dev, libzmq5-dev
 Replaces: libzmq5-dev
 Provides: libzmq5-dev
